/**
 */
package de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.provider;

import de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.util.WebPageModelAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IItemStyledLabelProvider;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class WebPageModelItemProviderAdapterFactory extends WebPageModelAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WebPageModelItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
		supportedTypes.add(IItemStyledLabelProvider.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.WebPage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected WebPageItemProvider webPageItemProvider;

	/**
	 * This creates an adapter for a {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.WebPage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createWebPageAdapter() {
		if (webPageItemProvider == null) {
			webPageItemProvider = new WebPageItemProvider(this);
		}

		return webPageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.MainPage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MainPageItemProvider mainPageItemProvider;

	/**
	 * This creates an adapter for a {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.MainPage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMainPageAdapter() {
		if (mainPageItemProvider == null) {
			mainPageItemProvider = new MainPageItemProvider(this);
		}

		return mainPageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.Page} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PageItemProvider pageItemProvider;

	/**
	 * This creates an adapter for a {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.Page}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPageAdapter() {
		if (pageItemProvider == null) {
			pageItemProvider = new PageItemProvider(this);
		}

		return pageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.Announcement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AnnouncementItemProvider announcementItemProvider;

	/**
	 * This creates an adapter for a {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.Announcement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAnnouncementAdapter() {
		if (announcementItemProvider == null) {
			announcementItemProvider = new AnnouncementItemProvider(this);
		}

		return announcementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.SubPage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SubPageItemProvider subPageItemProvider;

	/**
	 * This creates an adapter for a {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.SubPage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSubPageAdapter() {
		if (subPageItemProvider == null) {
			subPageItemProvider = new SubPageItemProvider(this);
		}

		return subPageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.HtmlInclude} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HtmlIncludeItemProvider htmlIncludeItemProvider;

	/**
	 * This creates an adapter for a {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.HtmlInclude}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createHtmlIncludeAdapter() {
		if (htmlIncludeItemProvider == null) {
			htmlIncludeItemProvider = new HtmlIncludeItemProvider(this);
		}

		return htmlIncludeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.HeaderTag} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HeaderTagItemProvider headerTagItemProvider;

	/**
	 * This creates an adapter for a {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.HeaderTag}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createHeaderTagAdapter() {
		if (headerTagItemProvider == null) {
			headerTagItemProvider = new HeaderTagItemProvider(this);
		}

		return headerTagItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.FileValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FileValueItemProvider fileValueItemProvider;

	/**
	 * This creates an adapter for a {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.FileValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFileValueAdapter() {
		if (fileValueItemProvider == null) {
			fileValueItemProvider = new FileValueItemProvider(this);
		}

		return fileValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.StringValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StringValueItemProvider stringValueItemProvider;

	/**
	 * This creates an adapter for a {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.StringValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStringValueAdapter() {
		if (stringValueItemProvider == null) {
			stringValueItemProvider = new StringValueItemProvider(this);
		}

		return stringValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.HeaderTagValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HeaderTagValueItemProvider headerTagValueItemProvider;

	/**
	 * This creates an adapter for a {@link de.tud.et.ifa.agtele.eclipse.webpage.webpagemodel.HeaderTagValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createHeaderTagValueAdapter() {
		if (headerTagValueItemProvider == null) {
			headerTagValueItemProvider = new HeaderTagValueItemProvider(this);
		}

		return headerTagValueItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void dispose() {
		if (webPageItemProvider != null) webPageItemProvider.dispose();
		if (mainPageItemProvider != null) mainPageItemProvider.dispose();
		if (pageItemProvider != null) pageItemProvider.dispose();
		if (announcementItemProvider != null) announcementItemProvider.dispose();
		if (subPageItemProvider != null) subPageItemProvider.dispose();
		if (htmlIncludeItemProvider != null) htmlIncludeItemProvider.dispose();
		if (headerTagItemProvider != null) headerTagItemProvider.dispose();
		if (fileValueItemProvider != null) fileValueItemProvider.dispose();
		if (stringValueItemProvider != null) stringValueItemProvider.dispose();
		if (headerTagValueItemProvider != null) headerTagValueItemProvider.dispose();
	}

}
